
 { to construct right hand side of the equations of the motion }

 UNIT  UnForces ;

 INTERFACE

 Uses
   UnConTyp ; { constants TVect3 TMatr33 }

 Procedure ClcRightHandCoor ( utc      : Extended ;
                              rc , vc  : TVect3 ;
                              Var
                                force  : TVect3 ) ;

 IMPLEMENTATION

 Uses
   UnForRom , { FromFixToTerraM FromTerraToFIxM }
   UnForFun , { TranspMatr procedure }
   UnForPnm , { ClcPrecMatr procedure }
   UnForceM , { TheMainForce procedure }
   UnForceT , { SolidTidePot procedure }
   UnForceH , { ForceDueToGeoHarm }
   UnForceP ; { ForceDueToPlanets }

 { to calculate the Forces }

 Procedure ClcRightHandCoor ( utc      : Extended ;
                              rc , vc  : TVect3 ;
                              Var
                                force  : TVect3 ) ;
 Var
   tt,dt  : Extended ; { terrestrial time TT }
   teph   : Extended ; { ephemeris time TDB }
   ct,tc  : TMatr33 ; { matrixes to link celestial and terrestrial }
   cf,fc  : TMatr33 ; { matrixes to link fixed and mean equator system }
 Begin

   { matrixes to link terrestrial and celestial system }
   FromFixToTerraM(utc,0.0,teph,ct); { UnForRom for TDB and matrix }
   TranspMatr(ct,tc);    { UnForFun for matrix from TRS to CRS }

   { coef. variations for nominal Love numbers UnForceT}
   SolidTidePot(teph,ct); { UnForceT CTideTwo[0,1,2] STideTwo[1,2] }

   { matrix to link fixed and mean equator system }
   ClcPrecMatr(MJD2000,teph,cf); { UnForPnm  precession matrix }
   TranspMatr(cf,fc);    { UnForFun  from mean to fixed equator }

   { the Earth as a material point with a mass M }
   TheMainForce(rc,force); { from UnForceZ }

   { to add zonal , tesseral and sectorial harmonics }
   ForceDueToGeoHarm(rc,ct,tc,force); { from UnForceH }

   { to add the beautiful Moon }
   ForceDueToMoon(teph,rc,fc,force); { from UnForceP }

   { to add the yellow Sun }
   ForceDueToSun(teph,rc,fc,force);  { from UnForceP }

   { to add Solar radiation pressure }
   ForceDueToSolPres(teph,rc,fc,force); { from UnForceP }

 End;

 END.
