
 UNIT UnrfNorS ; { to read two-line elements format of the elements }

 INTERFACE

 Uses
   UnConTyp ; { type TElemRec }

 Function ToGetNoradNumber ( snum : String ) : LongInt ;

 function ToGetLaunchNumber ( st  : String ) : LongInt ;

 Procedure ToReadNoradElem ( sf , sp  : string ;  var  el  : TElemRec ) ;

 IMPLEMENTATION

 Uses
   UnForPrt , { prtf text file }
   UnForDat , { for TransDateToMJD }
   UnForStr ; { procedures ToEraseSomeBlanks ToReplaceBlanks }

 Function ToGetNoradNumber ( snum  : String ) : LongInt ;
 Var
   i,l     : Byte ;
   err     : Integer ;
   ch      : Char ;
   sa      : String ;
   numl    : LongInt ;
   nums    : LongInt ;
 Begin
   nums:=100000;
   sa:=snum;
   l:=Length(sa);
   If  l < 2
     Then
       Begin
         ToGetNoradNumber:=nums;
         Exit ;
       end;
   For i:=1 To l Do
     Begin
       ch:=sa[i];
       If  ch = ' '  Then  ch:='1';
       If  NOT ( ch IN [ '0'..'9' ] )
         Then
           ch:='0';
       sa[i]:=ch;
     End;
   Val(sa,numl,err);
   If  err = 0  Then  nums:=numl;
   ToGetNoradNumber:=nums;
 End;

 function ToGetPartNumber ( ca  : Char ) : LongInt ;
 begin
   case  ca  of
    'A' : ToGetPartNumber:=1;
    'B' : ToGetPartNumber:=2;
    'C' : ToGetPartNumber:=3;
    'D' : ToGetPartNumber:=4;
    'E' : ToGetPartNumber:=5;
    'F' : ToGetPartNumber:=6;
    'G' : ToGetPartNumber:=7;
    'H' : ToGetPartNumber:=8;
    'I' : ToGetPartNumber:=9
    else  ToGetPartNumber:=10;
   end; { case }
 end;

 function ToGetLaunchNumber ( st  : String ) : LongInt ;
 var
   sa  : String ;
   ca  : Char ;
   ns  : LongInt;
 begin
   sa:=Copy(st,1,5);
   ca:=st[6];
   ns:=100*ToGetNoradNumber(sa)+ToGetPartNumber(ca);
   ToGetLaunchNumber:=ns;
 end;

 Procedure ToGetDateFromString ( st       : String ;
                                 Var  el  : TElemRec ;  { type UnConTyp }
                                 Var  b   : Boolean  ) ;
 Var
   ErrVal       : Integer ;
   Day,
   Month,Year   : Integer ;
   PDay,d,v     : Extended ;
   sa,sy,sd,sn  : String ;
 Begin
   b:=FALSE;
   sa:=Copy(st,3,5);  { number of a satellite from norad }
   el.satnord:=ToGetNoradNumber(sa);  { NORAD number }
   sa:=Copy(st,10,6); { number of satellite as date of launch }
   el.satnuml:=ToGetLaunchNumber(sa);
   sy:=Copy(st,19,2);
   sd:=Copy(st,21,12);
   sn:=Copy(st,33,11);
   ToReplaceBlanks(sy); { UnForStr }
   Val(sy,Year,ErrVal);
   If  ErrVal <> 0  Then  Exit ;
   If  Year < 51   Then  Year:=2000+Year;
   If  Year < 100  Then  Year:=1900+Year;
   Day:=31;
   Month:=12;
   Year:=Year-1;
   d:=FromDateToMJD(Day,Month,Year,0,0,0.0); { UnForDat }
   ToReplaceBlanks(sd); { UnForStr }
   Val(sd,PDay,ErrVal);
   If  ErrVal <> 0
     Then
       Exit ;
   d:=d+PDay;
   el.t:=d; { modified julian date of elements }
   ToReplaceBlanks(sn);  { UnForStr }
   Val(sn,v,ErrVal);
   If  ErrVal <> 0  Then  v:=0.0;
   el.dn:=v; { dn/dt n mean motion rev/day per day }
   b:=TRUE;
 End;

 Procedure ToGetElementsFromString ( st       : String ;
                                     Var  el  : TElemRec ; { UnConTyp }
                                     Var  b   : Boolean  ) ;
 Var
   ErrVal  : Integer ;
   sc      : String ;
   ac      : Extended ;
 Begin
   b:=FALSE;
   sc:=Copy(st,9,8); { inclination in degree }
   ToReplaceBlanks(sc);
   Val(sc,ac,ErrVal);
   If  ErrVal <> 0  Then  Exit ;
   if  ac < 0.00015  then  ac:=0.00025; { for inclination in degree }
   el.ai:=ac;
   sc:=Copy(st,18,8); { ascending node in degree }
   ToReplaceBlanks(sc);
   Val(sc,ac,ErrVal);
   If  ErrVal <> 0  Then  Exit ;
   el.au:=ac;
   sc:=Copy(st,27,7); { pack eccentricity }
   ToReplaceBlanks(sc);
   sc:='0.'+sc;
   Val(sc,ac,ErrVal);
   If  ErrVal <> 0  Then  Exit ;
   el.ae:=ac;
   sc:=Copy(st,35,8); { argument of perigei in degree }
   ToReplaceBlanks(sc);
   Val(sc,ac,ErrVal);
   If  ErrVal <> 0  Then  Exit ;
   el.ao:=ac;
   sc:=Copy(st,44,8); { mean anomaly in degree }
   ToReplaceBlanks(sc);
   Val(sc,ac,ErrVal);
   If  ErrVal <> 0  Then  Exit ;
   el.am:=ac;
   sc:=Copy(st,53,11); { mean motion in rev/day }
   ToReplaceBlanks(sc);
   Val(sc,ac,ErrVal);
   If  ErrVal <> 0  Then  Exit ;
   el.an:=ac;
   b:=TRUE;
 End;

 Function MagFromNulloLine ( st  : String ) : Single ;
 Var
   vm  : Single ;
   ls  : Byte ;
   er  : Integer ;
   sa  : String[5];
 Begin
   ls:=Length(st);
   If  ls > 35
     Then { may be magnitude information }
       Begin
         sa:=Copy(st,31,5);
         Val(sa,vm,er);
         If  er <> 0
           Then
             vm:=99; { no real number in string }
        End
     Else
       vm:=99; { string is too short }
   MagFromNulloLine:=vm;
 End;

 Procedure ToReadNoradElem ( sf , sp  : string ;  var  el  : TElemRec ) ;
 Var
   tlefil  : Text ; { file to read }
   StrN    : String[16] ;
   zf,zp   : String ;
   StrTmp  : String ;
   ba,bb   : Boolean ;
 begin
   zf:=WithoutBlanksCopy(sf); { UnForStr name of file }
   zp:=WithoutBlanksCopy(sp); { UnForStr pattern for name of satellite }
   writeln('file with elements ''',zf,'''');
   writeln('pattern in file    ''',zp,'''');
   writeln(prtf,'file with elements ''',zf,''''); { UnForPrt }
   writeln(prtf,'pattern in file    ''',zp,'''');
   Assign(tlefil,zf);   { file with tle format }
   ReSet(tlefil);           { to open to read }
 Repeat
   ReadLn(tlefil,StrTmp);   { UnTleFil }
   if  Pos(zp,StrTmp) > 0  then
     begin
       writeln(StrTmp);
       writeln(prtf,StrTmp);
       StrN:=Copy(StrTmp,1,16); { name of satellite }
       el.satname:=StrN;
       el.stdmag:=MagFromNulloLine(StrTmp); { var from UnConTyp }
       ReadLn(tlefil,StrTmp);
       writeln(StrTmp);
       writeln(prtf,StrTmp);
       ToGetDateFromString(StrTmp,el,ba);
       ReadLn(tlefil,StrTmp);
       writeln(StrTmp);
       writeln(prtf,StrTmp);
       ToGetElementsFromString(StrTmp,el,bb);
     end;
 Until  EOF(tlefil) ;
   Close(tlefil);           { that is all }
 end;

 END.
