unit unrsptre ; { to read file with data in SP3 format }
interface
procedure ToReadSptre ( ia  : Byte ;  { number of file }
                        sp , sf  , sr  : string ) ; { to main program }
procedure DateForRestore ( var  ft  : Text ; ia  : Byte ; sr  : string ) ;
implementation
uses
  UnForPrt , { prtf text file }
  UnForStr , { function WithoutBlanksCopy }
  UnForDat ; { function FromDatetoMJD }

{ text file may be without symbol end of string }

function ToGetCurStr ( var f  : Text ) : String ;
var { to select current string with $0A $0D }
  k  : Byte ;
  a  : Byte ;
  c  : Char ;
  s  : String ;
  b  : Boolean ;
begin
  s:='';
  b:=False ;    { default }
  k:=0;
repeat
  Read(f,c); { the next symbol from the text file }
  a:=Ord(c);
  if  ( ( a <> $0A ) and ( a <> $0D ) ) { may be $0A without $0D }
    then
      s:=s+c
    else
      if  a = $0A
        then
          b:=True; { the end of current string }
  k:=k+1;
until  ( b or ( k > 253 ) ) ;
  ToGetCurStr:=s;
end;

{ for Earth rotation parameters :
  tp  moment in MJD for ERP 
  xp  x pole value in arcsec
  yp  y pole value in arcsec
  du  delta UT in second of time for moment tp
  vu  length of day in second of time per day }

procedure ForEarParm ( sr  : string ;
                       var  tp , xp , yp , du , vu  : extended ;
                       var  bo  : boolean ) ; { true for ERParam }
var
  fr  : text ;    { text file with ERParameters }
  kx  : longint ; { integer x pole from file }
  ky  : longint ; { integer y pole from file }
  ku  : longint ; { integer delta UT from file }
  kv  : longint ; { integer LOD from file }
  ie  : integer ; { error for Val procedure }
  ir  : integer ; { to sum abs value of error }
  zr  : string ;  { name of file with ERParam }
  zt  : string ;  { temporary string to read }
begin
  bo:=false; { default }
  xp:=0.0;   { default }
  yp:=0.0;   { default }
  zr:=WithoutBlanksCopy(sr); { UnForStr name of file }
  assign(fr,zr); { file with ERP }
{$I-}
  reset(fr);     { to open to read }
{$I+}
  if  IOResult <> 0  { file not exists }
    then  Exit ;     { to go with false for ERP }
repeat           { to read string by string to find our information }
  zt:=ToGetCurStr(fr); { to read the next string }
until  EOF(fr) or ( Pos('(10**-6")',zt) > 0 ) ; { to find our string }
  if  not EOF(fr)  then  { after string with unit for parameters }
    begin                { it is possible to read their values }
      zt:=ToGetCurStr(fr); { to read the string with values }
      Val(Copy(zt,1,8),tp,ie);  { moment in mjd for ERP real }
      ir:=Abs(ie);
      Val(Copy(zt,9,8),kx,ie);  { for x pole value integer }
      ir:=ir+Abs(ie);
      Val(Copy(zt,17,8),ky,ie); { for y pole value integer }
      ir:=ir+Abs(ie);
      Val(Copy(zt,25,9),ku,ie); { for delta UT value integer }
      ir:=ir+Abs(ie);
      Val(Copy(zt,34,7),kv,ie); { for LOD value integer }
      ir:=ir+Abs(ie);
    end;
  close(fr); { that is all }
  if  ir = 0  then { success to read our ERParam }
    begin
      xp:=1.0e-6*kx; { our value from integer to real }
      yp:=1.0e-6*ky; { our value from integer to real }
      du:=1.0e-7*ku; { our value from integer to real }
      vu:=1.0e-7*kv; { our value from integer to real }
      bo:=true;  { for our ERP }
    end;
end;

{ function for moment from string }

function ToGetMoment ( s  : string ) : extended ;
var
  nd  : integer ;  { day }
  nm  : integer ;  { month }
  ny  : integer ;  { year }
  kh  : integer ;  { hour }
  km  : integer ;  { minute }
  ks  : integer ;  { second }
  ie  : integer ;  { error index }
  ts  : extended ; { real second }
begin
  Val(Copy(s,4,4),ny,ie);  { year }
  Val(Copy(s,9,2),nm,ie);  { month }
  Val(Copy(s,12,2),nd,ie); { day }
  Val(Copy(s,15,2),kh,ie); { hour }
  Val(Copy(s,18,2),km,ie); { minute }
  Val(Copy(s,21,2),ks,ie); { second }
  ts:=ks;
  ToGetMoment:=FromDatetoMJD(nd,nm,ny,kh,km,ts); { UnForDat function }
end;

{ sp pattern to find object in this file
  sf string with name of file for data in SP3 format
  sr string with name of file for Earth rotation parameter }

procedure ToReadSptre ( ia  : Byte ;  { number of file }
                        sp , sf  , sr  : string ) ; { to main program }
var
  fs  : Text ;   { file with data to read }
  fw  : Text ;   { temporary file to write data for selected object }
  tc  : extended ; { current moment in MJD }
  xc  : extended ; { x position in km }
  yc  : extended ; { y position in km }
  zc  : extended ; { z position in km }
  tp  : extended ; { moment in MJD for ERP }
  xp  : extended ; { x pole value in arcsec }
  yp  : extended ; { y pole value in arcsec }
  du  : extended ; { delta UT in second of time for moment tp }
  vu  : extended ; { length of day in second of time per day }
  dt  : extended ; { delta UT in second pf time for current moment }
  ie  : integer ;  { temporary for Val procedure }
  bo  : boolean ;  { true not error to obtain ERParam }
  sc  : string ;   { current string }
  zf  : string ;   { name of text file with data }
  zp  : string ;   { pattern to find object in text file }
begin
  ForEarParm(sr,tp,xp,yp,du,vu,bo); { for Earth rotation parameters }
  zp:=WithoutBlanksCopy(sp); { UnForStr pattern to find }
  zf:=WithoutBlanksCopy(sf); { UnForStr name of file }
  writeln('pattern in file    ''',zp,'''');
  writeln('file with  data    ''',zf,'''');
  writeln(prtf,'pattern in file    ''',zp,'''');
  writeln(prtf,'file with  data    ''',zf,''''); { UnForPrt }
  assign(fw,'xyz.tmp');      { temporary file for data for our object }
  if  ia = 1         { the first file in list }
    then             { new temporary file }
      begin
        rewrite(fw); { to open to write }
        writeln(fw,'pattern in file to find object  ''',zp,'''');
        writeln(fw,'the first  file with  SP3 data  ''',zf,'''');
      end
    else             { the next file in list }
      append(fw);    { to add information to the end of text file }
  assign(fs,zf); { our text file }
  reset(fs);     { to open to read }
repeat           { to find the first information about moment }
  sc:=ToGetCurStr(fs);        { to read the next string }
until  ( Pos('* ',sc) = 1 ) ; { a first string with moment information }
repeat
  if  ( Pos('* ',sc) = 1 )  then { this is string with moment }
    begin                    { to find data for our object }
      tc:=ToGetMoment(sc);   { function for moment from string }
      if  bo                    { true ERP parameter delta UT }
        then  dt:=du-vu*(tc-tp) { for current moment in second of time }
        else  dt:=0.0;          { simple nullo without ERP information }
      writeln(sc,tc:25:10);
    repeat
      sc:=ToGetCurStr(fs); { to read the next string }
      if  Pos(zp,sc) > 0  then  { to compare with pattern our object }
        begin                       { it is our object }
          writeln(Copy(sc,1,75));   { simple print to screen }
          Val(Copy(sc,5,14),xc,ie);  { x position in km }
          Val(Copy(sc,19,14),yc,ie);  { y position in km }
          Val(Copy(sc,33,14),zc,ie);  { z position in km }
          writeln(fw,tc:16:10,xc:14:6,yc:14:6,zc:14:6,
                              xp:10:6,yp:10:6,dt:11:7);
        end;
    until  ( Pos('* ',sc) = 1 ) or EOF(fs) ;
    end;
until  EOF(fs) ;
  close(fs);     { that is all to read  text file }
  close(fw);     { that is all to write text file }
end;
{ for main program ReglOrbi.pas 
  ft  text file with information }
procedure DateForRestore ( var  ft  : Text ; ia  : Byte ; sr  : string ) ;
var
  fw  : Text ;
  tc  : extended ; { current moment in MJD }
  ta  : extended ; { start  moment in mjd for list of date }
  tb  : extended ; { finish moment in mjd for list of date }
  tp  : extended ; { moment in MJD for ERP }
  xp  : extended ; { x pole value in arcsec }
  yp  : extended ; { y pole value in arcsec }
  du  : extended ; { delta UT in second of time for moment tp }
  vu  : extended ; { length of day in second of time per day }
  dt  : extended ; { delta UT in second pf time for current moment }
  ie  : integer ;  { temporary for Val procedure }
  bo  : boolean ;  { true not error to obtain ERParam }
  nd  : integer ;  { day }
  nm  : integer ;  { month }
  ny  : integer ;  { year }
  kh  : integer ;  { hour }
  km  : integer ;  { minute }
  ks  : integer ;  { second }
  xs  : extended ; { real second }
  ns  : integer ;  { step in second }
  ds  : extended ; { real step in day }
begin
  ForEarParm(sr,tp,xp,yp,du,vu,bo); { for Earth rotation parameters }
  readln(ft,ny,nm,nd,kh,km,ks);     { start  date text file as parameter }
  xs:=ks; { real second }
  ta:=FromDateToMJD(nd,nm,ny,kh,km,xs); { UnForDat start  moment }
  readln(ft,ny,nm,nd,kh,km,ks);     { finish date text file as parameter }
  xs:=ks; { real second }
  tb:=FromDateToMJD(nd,nm,ny,kh,km,xs); { UnForDat finish moment }
  readln(ft,ns);    { step in second }
  ds:=ns/86400.0e0; { real step in day }
  assign(fw,'xyz.tmp');      { temporary file for data for our object }
  if  ia = 1         { the first date in list }
    then             { new interval for print }
      rewrite(fw)    { to open to write }
    else             { the next  date in list }
      append(fw);    { to add information to the end of text file }
  tc:=ta;            { to start }
repeat               { step by step with second }
  if  bo                    { true ERP parameter delta UT }
    then  dt:=du-vu*(tc-tp) { for current moment in second of time }
    else  dt:=0.0;          { simple nullo without ERP information }
  writeln(fw,tc:20:10,xp:12:6,yp:12:6,dt:13:7);
  tc:=tc+ds;         { the next value of moment }
until  ( tc > (tb+1.0e-8) ) ;   { before finish moment }
  close(fw);         { information is in file now }
end;
end.
