unit UnTreRoc ; { to change position velosity between systems }
interface
uses
  UnConTyp ; { type TVect3 TMatr33 }
{ initial position velosity from true to fixed equator }
procedure PosVelToFixEqu ( tb  : Extended ;
                           ra , va  : TVect3 ;
                           var  rb , vb  : TVect3 ) ;
{ initial position velosity from fixed to true equator }
procedure PosVelToTruEqu ( tb  : Extended ;
                           rb , vb  : TVect3 ;
                           var  ra , va  : TVect3 ) ;
{ vector to change from fixed to terra system }
procedure VecToTerra ( t  : Extended ;     { current moment in mjd }
                       a  : Extended ;     { x pole value in radian }
                       b  : Extended ;     { y pole value in radian }
                       d  : Extended ;     { value for delta(UT) }
                       z  : TVect3 ;       { vector in fixed equator }
                       var  r : TVect3 ) ; { result terra system vector }
implementation
uses
  UnForRom , { FromTrueToFixEquM procedure }
  UnForFun ; { MultMatrVec procedure }
{ initial position velosity from true to fixed equator }
procedure PosVelToFixEqu ( tb  : Extended ;
                           ra , va  : TVect3 ;
                           var  rb , vb  : TVect3 ) ;
var
  rm  : TMatr33 ; { UnConTyp }
begin
  FromTrueToFixEquM(tb,rm); { simple matrix UnForRom }
  MultMatrVec(rm,ra,rb);    { to fixed equator system UnForFun }
  MultMatrVec(rm,va,vb);    { to fixed equator system }
end;
{ initial position velosity from fixed to true equator }
procedure PosVelToTruEqu ( tb  : Extended ;
                           rb , vb  : TVect3 ;
                           var  ra , va  : TVect3 ) ;
var
  rm  : TMatr33 ; { UnConTyp }
begin
  FromFixToTrueEquM(tb,rm); { simple matrix UnForRom }
  MultMatrVec(rm,rb,ra);    { to true equator system UnForFun }
  MultMatrVec(rm,vb,va);    { to true equator system }
end;
{ vector to change from fixed to terra system }
procedure VecToTerra ( t  : Extended ;     { current moment in mjd }
                       a  : Extended ;     { x pole value in radian }
                       b  : Extended ;     { y pole value in radian }
                       d  : Extended ;     { value for delta(UT) }
                       z  : TVect3 ;       { vector in fixed equator }
                       var  r : TVect3 ) ; { result terra system vector }
var
  w  : Extended ; { value for TDB without using }
  p  : TMatr33 ;  { UnConTyp matrix from fixed to terra equator }
begin
  FromFixToTerraP(t,a,b,d,w,p); { UnForRom result to matrix p }
  MultMatrVec(p,z,r); { to terra equator system UnForFun with pole pos }
end;
end.
